
#include <windows.h>
#include <stdio.h>
#include <conio.h>


#define ARRAY_LENGTH(a)	(sizeof(a)/sizeof(a[0]))

int main( int argc, char **argv )
{
	HANDLE hComPort=INVALID_HANDLE_VALUE;
	BOOL bSuccess;
	BYTE buffer[63];
	BYTE cnt=0;


	do
	{
		if( argc < 2 )
		{
			printf("usage: com_tx COM<x>\n");
			break;
		}

		hComPort = CreateFile( argv[1],
			GENERIC_READ | GENERIC_WRITE,
			0,    // comm devices must be opened w/exclusive-access 
			NULL, // no security attributes 
			OPEN_EXISTING, // comm devices must use OPEN_EXISTING 
			0,    // not overlapped I/O 
			NULL  // hTemplate must be NULL for comm devices 
			);

		if ( hComPort == INVALID_HANDLE_VALUE )
		{
			printf("%s open failed, %x\n", argv[1], GetLastError() );
			break;
		}

		DCB dcb ;

		ZeroMemory( &dcb, sizeof(dcb) ) ;

		dcb.DCBlength = sizeof(dcb);
		dcb.BaudRate = 115200 ;
		dcb.ByteSize = 8 ;
		dcb.StopBits = ONESTOPBIT;

		bSuccess = SetCommState( hComPort, &dcb ) ;
		if(!bSuccess)
		{
			printf("ERROR: SetCommState failed, %x\n", GetLastError() );
			break;
		}

		DWORD dwWritten;

		while(!_kbhit())
		{
			for(int i=0;i<sizeof(buffer);i++)
			{
				buffer[i]=cnt++;
			}

			printf("%08x Write\n", GetTickCount() );


			bSuccess = WriteFile( hComPort, buffer, sizeof(buffer), &dwWritten, NULL );
			if(!bSuccess || dwWritten!=sizeof(buffer))
			{
				printf("ERROR: Write failed, %x\n", GetLastError() );
				break;
			}

			Sleep(1000);

		}

	}while(0);

	if( INVALID_HANDLE_VALUE != hComPort )
	{
		CloseHandle(hComPort);
	}

	return 0;
}