#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "libsub.h"

void hexdump(void *buf, int size);

//------------------------------------------------------------------------------

int main( int argc, char **argv )
{
	int status = -1;
	char sernum[5];
	int bc;
	BYTE cnt=0;

	sub_handle dev = NULL ;

	do
	{

		dev = sub_open( 0 );
		if( !dev )
		{
			printf("ERROR Cannot open SUB20 device\n", sernum );
			break;
		}

		bc = sub_get_serial_number( dev, sernum, sizeof(sernum) );
		if( bc < 0 )
		{
			status = bc;
			break;
		}

		printf("=SUB20 %s is RS slave\n", sernum );


		status = sub_rs_set_config( dev, 
			RS_RX_ENABLE|RS_TX_ENABLE|RS_CHAR_8|RS_STOP_1|RS_PARITY_NONE, 115200 );
		if( status )
		{
			printf("sub_rs_set_config failed\n");
			break;
		}

		status = sub_fifo_config(dev, FIFO_SELECT_UART );
		if( status )
		{
			break;
		}

		BYTE buf[128];

		while( !_kbhit() )
		{
			bc = sub_fifo_read( dev, (char*)buf, sizeof(buf), 100 );
			if( bc < 0 )
			{
				status = sub_get_errno();
				break;
			}
			else if( bc > 0 )
			{
				hexdump(buf, bc );

				for(int i=0;i<bc;i++)
				{
					if( cnt != buf[i] )
					{
						printf("\nERROR: got %02x, expected %02x\n", buf[i], cnt );
						cnt=buf[i];
					}

					cnt++;
				}
			}
		}

	}while(0);

	if( dev )
	{
		sub_close( dev );
	}

	if( status )
	{
		status = sub_get_errno() ;
		char* str = sub_strerror( status );

		if(str)
		{
			printf("ERROR: %s\n", str );
		}
		else
		{
			printf("ERROR: %d(%x)\n", status, status );
		}
	}


	return 0;

}

#define hexdump_putc	putchar
//------------------------------------------------------------------------------

static const char hex[]="0123456789abcdef";
void print_hex(unsigned long val, int bc )
{
	int i;
	unsigned long c;
	for(i=0;i<bc;i++)
	{
		c=val>>(8*(bc-i)-4);
		hexdump_putc(hex[c&0xf]);
		c=val>>(8*(bc-i)-8);
		hexdump_putc(hex[c&0xf]);
	}
}
/*----------------------------------------------------------------------------*/
void print_string(char* str)
{
	printf(str);
}
/*----------------------------------------------------------------------------*/
int cnt = 0;
void hexdump(void *buf, int size)
{
	for(int i=0;i<size;i++)
	{
		print_hex(((char*)buf)[i], 1);
		hexdump_putc(' ');
		cnt++;
		if(cnt==16)
		{
			hexdump_putc('\n');
			cnt=0;
		}
	}
}

/*----------------------------------------------------------------------------*/
